Bug 619593 - Review Request: topgit - A different patch queue manager
Review Request: topgit - A different patch queue manager
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ben Boeckel
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-29 17:06 EDT by Thomas Moschny
Modified: 2011-01-03 15:08 EST (History)
4 users (show)

See Also:
Fixed In Version: topgit-0.9-0.2.git9b25e848.fc13
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-01-03 12:33:28 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mathstuf: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Thomas Moschny 2010-07-29 17:06:53 EDT
Spec URL: http://thm.fedorapeople.org/topgit/topgit.spec
SRPM URL: http://thm.fedorapeople.org/topgit/topgit-0.8-1.git5aed7e7b.fc13.src.rpm

Description:
TopGit aims to make handling of large amount of interdependent topic
branches easier. In fact, it is designed especially for the case when
you maintain a queue of third-party patches on top of another (perhaps
Git-controlled) project and want to easily organize, maintain and
submit them - TopGit achieves that by keeping a separate topic branch
for each patch and providing few tools to maintain the branches.
Comment 1 Lameire Alexis 2010-07-31 05:51:32 EDT
Hi,

since I'm not sponsored, this informal eview is not official.

-> rpmlint is ok 

$ rpmlint topgit-0.8-1.git5aed7e7b.fc13.src.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.

I have checked the spec file, it looks quite good

[ok] MUST: The package must be named according to the Package Naming Guidelines .
[ok] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] . 
[ok] MUST: The package must meet the Packaging Guidelines .
[ok] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
[ok] MUST: The License field in the package spec file must match the actual license. [3]
[ok] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
[ok] MUST: The spec file must be written in American English. [5]
[ok] MUST: The spec file for the package MUST be legible. [6]
[ok] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
[ok] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
[ok] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
[ok] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[ok] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
[ok] MUST: Packages must NOT bundle copies of system libraries.[11]
[ok] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
[ok] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
[ok] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
[ok] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]
[ok] MUST: Each package must consistently use macros. [16]
[ok] MUST: The package must contain code, or permissable content. [17]
[ok] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
[ok] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
[ok] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
[ok] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
[ok] MUST: All filenames in rpm packages must be valid UTF-8. [24]
[ok] SHOULD: The reviewer should test that the package builds in mock. [27]
SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.[32]

only the least SHOULD can pose a problem ;) else all is good :)
Comment 2 Thomas Moschny 2010-09-08 05:26:35 EDT
Thanks for that informal review!

Talked to upstream about man pages. There already was some effort to create man pages from the help texts that are already there, see http://bugs.debian.org/499071.
Comment 3 Ben Boeckel 2010-09-08 09:36:40 EDT
I'll take this. Sounds like some things I do every now and then :) .
Comment 4 Ben Boeckel 2010-09-11 13:16:34 EDT
-> rpmlint is ok 

% lintmock fedora-14-x86_64-bb                                                   -
topgit.noarch: W: non-conffile-in-etc /etc/bash_completion.d/tg-completion.bash
topgit.noarch: W: no-manual-page-for-binary tg
2 packages and 0 specfiles checked; 0 errors, 2 warnings.

[ok] MUST: The package must be named according to the Package Naming Guidelines.
[ok] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[ok] MUST: The package must meet the Packaging Guidelines.
[ok] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[ok] MUST: The License field in the package spec file must match the actual license.
[ok] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[ok] MUST: The spec file must be written in American English.
[ok] MUST: The spec file for the package MUST be legible.
[FAIL] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

% sha1sum 5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz ../SOURCES/5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz
1b38e02c8f55a9029c081562aaec3e787614689e  5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz
c0a1ea211a7eb4732987cc299c44095a7f41673d  ../SOURCES/5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz

Tarball was fetched with `spectool -g`.

[ok] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[ok] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[ok] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[ok] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[ok] MUST: Packages must NOT bundle copies of system libraries.
[ok] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[FAIL] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.

/etc/bash_completion.d/ isn't owned. I'd recommend splitting off the bash completion into a separate file and Requires: topgit and Requires: bash-completion.

[ok] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[ok] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[ok] MUST: Each package must consistently use macros.
[ok] MUST: The package must contain code, or permissable content.
[ok] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[ok] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[ok] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[ok] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
[ok] MUST: All filenames in rpm packages must be valid UTF-8.
[ok] SHOULD: The reviewer should test that the package builds in mock.
[ok] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

Working off the Debian patches. Should file a tracking bug here once accepted.

=============

One weird thing I see is %doc at the end of %files. I'd also recommend adding a trailing slash to the %{_libexecdir} and %{_datarootdir} lines to better indicate that they are directories.
Comment 5 Thomas Moschny 2010-09-26 09:18:23 EDT
(In reply to comment #4)
> [FAIL] MUST: The sources used to build the package must match the upstream
> source, as provided in the spec URL. Reviewers should use md5sum for this task.
> If no upstream URL can be specified for this package, please see the Source URL
> Guidelines for how to deal with this.
> 
> % sha1sum 5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz
> ../SOURCES/5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz
> 1b38e02c8f55a9029c081562aaec3e787614689e 
> 5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz
> c0a1ea211a7eb4732987cc299c44095a7f41673d 
> ../SOURCES/5aed7e7bad8c23080139b452adac75d2571b6dfa.tar.gz
> 
> Tarball was fetched with `spectool -g`.

Yeah, the problem is gitweb, which seems to embed a datestamp or something like this in the tarfile, causing it to have a different hash each time one downloads it.

I changed the specfile to refer to the zipfile instead, which doesn't seem to have that problem.

(Note that this problem would persist even when we don't packaged a git snapshot, but a released version, as there currently is no real upstream website other than gitweb.)

> [FAIL] MUST: A package must own all directories that it creates. If it does not
> create a directory that it uses, then it should require a package which does
> create that directory.
> 
> /etc/bash_completion.d/ isn't owned. I'd recommend splitting off the bash
> completion into a separate file and Requires: topgit and Requires:
> bash-completion.

That's overkill imho. Following what other packages do, I simply own /etc/bash_completion.d now.

> One weird thing I see is %doc at the end of %files.

Moved to the top of the %files section.

> I'd also recommend adding a
> trailing slash to the %{_libexecdir} and %{_datarootdir} lines to better
> indicate that they are directories.

Slashes added.


Spec URL: http://thm.fedorapeople.org/topgit/topgit.spec
SRPM URL: http://thm.fedorapeople.org/topgit/topgit-0.8-2.git9404aa1a.fc13.src.rpm

%changelog
* Mon Sep 13 2010 Thomas Moschny <..> - 0.8-2.git9404aa1a
- Update to revision 9404aa1a.
- Specfile fixes as suggested in the review.
Comment 6 Thomas Moschny 2010-10-10 17:33:18 EDT
Spec URL: http://thm.fedorapeople.org/topgit/topgit.spec
SRPM URL:
http://thm.fedorapeople.org/topgit/topgit-0.9-0.1.git8b0f1f9d.fc13.src.rpm

%changelog
* Sun Oct 10 2010 Thomas Moschny <..> - 0.9-0.1.git8b0f1f9d
- Update to revision 8b0f1f9d.

There seems to be a 0.9 release imminent, so I decided to use a pre-release snapshot naming scheme.
Comment 7 Thomas Moschny 2010-12-11 07:34:39 EST
Spec URL: http://thm.fedorapeople.org/topgit/topgit.spec
SRPM URL: http://thm.fedorapeople.org/topgit/topgit-0.9-0.2.git9b25e848.fc14.src.rpm

%changelog
* Sat Dec 11 2010 Thomas Moschny <..> - 0.9-0.2.git9b25e848
- Update to revision 9b25e848.


Ben, are you still interested in reviewing this package?
Comment 8 Ben Boeckel 2010-12-11 11:48:25 EST
Yep, sorry. Got buried in other stuff.

Looks good to me.

APPROVED.
Comment 9 Thomas Moschny 2010-12-13 05:57:00 EST
Thanks for the review!

New Package SCM Request
=======================
Package Name: topgit
Short Description: A different patch queue manager
Owners: thm
Branches: f13 f14 el5 el6
Comment 10 Jason Tibbitts 2010-12-13 13:32:27 EST
Git done (by process-git-requests).
Comment 11 Fedora Update System 2010-12-18 17:59:36 EST
topgit-0.9-0.2.git9b25e848.fc13 has been submitted as an update for Fedora 13.
https://admin.fedoraproject.org/updates/topgit-0.9-0.2.git9b25e848.fc13
Comment 12 Fedora Update System 2010-12-18 17:59:45 EST
topgit-0.9-0.2.git9b25e848.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/topgit-0.9-0.2.git9b25e848.el5
Comment 13 Fedora Update System 2010-12-18 17:59:55 EST
topgit-0.9-0.2.git9b25e848.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/topgit-0.9-0.2.git9b25e848.fc14
Comment 14 Fedora Update System 2010-12-19 12:32:31 EST
topgit-0.9-0.2.git9b25e848.el5 has been pushed to the Fedora EPEL 5 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update topgit'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/topgit-0.9-0.2.git9b25e848.el5
Comment 15 Fedora Update System 2011-01-03 12:33:22 EST
topgit-0.9-0.2.git9b25e848.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 16 Fedora Update System 2011-01-03 14:55:35 EST
topgit-0.9-0.2.git9b25e848.fc14 has been pushed to the Fedora 14 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 17 Fedora Update System 2011-01-03 15:08:50 EST
topgit-0.9-0.2.git9b25e848.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.